﻿namespace YieldKeywordDemo
{
    using System;
    using System.Collections;

    public class PowerList
    {
        public IEnumerable Power(int number, int exponent)
        {
            int valueCounter = 0;
            int currentResult = 1;
            while (valueCounter++ < exponent) {
                currentResult = currentResult * number;
                yield return currentResult;
            }
        }
    }
    
    class Program
    {
        static void Main(string[] args)
        {
            PowerList demoObj = new PowerList();

            // Display powers of 2 up to the exponent 10
            foreach (int i in demoObj.Power(2, 10)) {
                Console.Write("{0} ", i);
            }

            PowerList demoObj2 = new PowerList();
            IEnumerable power = demoObj2.Power(2, 10);
            IEnumerator e = power.GetEnumerator();
            e.MoveNext();
            int value = (int)e.Current;
            Console.WriteLine("\n{0}", value);

            Console.ReadKey(true);
        }
    }
}